import { TypedEmitter } from 'tiny-typed-emitter';
const InterfaceType = 'pwm';
export class PWMInterface extends TypedEmitter {
    constructor(configuration) {
        super();
        this.interfaceType = InterfaceType;
        this.configuration = configuration;
    }
    retransmit() {
        throw new Error('Method not implemented.');
    }
    // TODO: add real implementation
    downstreamData(data) {
        console.log(data);
    }
    sendPWMSignal(pwmSignal) {
        this.emit('upstreamData', pwmSignal);
        this.downstreamData(pwmSignal);
    }
}
export class ConstructablePWMInterface {
    constructor(signals) {
        this.interfaceType = InterfaceType;
        this.signals = signals;
    }
    getDescription() {
        return {
            availableSignals: { pwm: this.signals },
        };
    }
    create(configuration) {
        return new PWMInterface(configuration);
    }
}
//# sourceMappingURL=connectionInterface.js.map